task mapping {

    File SAref_dir
    File STref_dir
    File fasta
	File fastq_1
	File fastq_2

	String sample
	String SAdocker
	String cluster_config
	String disk_size

	command <<<
		set -o pipefail
		set -e	

		STAR --genomeDir ${SAref_dir} --readFilesIn ${fastq_1} ${fastq_2} --runThreadN 20 --outFileNamePrefix OnePass_ 

		genomeDir=./twoPass
		STAR --runMode genomeGenerate --genomeDir $genomeDir --genomeFastaFiles ${STref_dir}/${fasta} --sjdbFileChrStartEnd OnePass_SJ.out.tab --sjdbOverhang 75 --runThreadN 20


		STAR --genomeDir $genomeDir --readFilesIn ${fastq_1} ${fastq_2} --runThreadN 20 --outFileNamePrefix ${sample}_
	>>>

	runtime {
		docker:SAdocker
    	cluster: cluster_config
    	systemDisk: "cloud_ssd 40"
    	dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
	}
	output {
		File aligned_sam = "${sample}_Aligned.out.sam"
	}
}
